Package org.eclipse.jdt.core.dom

## Class TypeParameter

- java.lang.Object
- - org.eclipse.jdt.core.dom.ASTNode
  - - org.eclipse.jdt.core.dom.TypeParameter

    public class TypeParameter
    extends ASTNode

Type parameter declaration node (added in JLS3 API).

     TypeParameter:
        { ExtendedModifier } Identifier [ extends Type { & Type } ]

Since:
  3.1
Restriction:
  This class is not intended to be instantiated by clients.

### Field Summary

Fields
`static ChildListPropertyDescriptor` `MODIFIERS_PROPERTY` The "modifiers" structural property of this node type (element type: `IExtendedModifier`) (added in JLS8 API).
`static ChildPropertyDescriptor` `NAME_PROPERTY` The "name" structural property of this node type (child type: `SimpleName`).
`static ChildListPropertyDescriptor` `TYPE_BOUNDS_PROPERTY` The "typeBounds" structural property of this node type (element type: `Type`).

### Fields inherited from class org.eclipse.jdt.core.dom.ASTNode

`ANNOTATION_TYPE_DECLARATION, ANNOTATION_TYPE_MEMBER_DECLARATION, ANONYMOUS_CLASS_DECLARATION, ARRAY_ACCESS, ARRAY_CREATION, ARRAY_INITIALIZER, ARRAY_TYPE, ASSERT_STATEMENT, ASSIGNMENT, BLOCK, BLOCK_COMMENT, BOOLEAN_LITERAL, BREAK_STATEMENT, CAST_EXPRESSION, CATCH_CLAUSE, CHARACTER_LITERAL, CLASS_INSTANCE_CREATION, COMPILATION_UNIT, CONDITIONAL_EXPRESSION, CONSTRUCTOR_INVOCATION, CONTINUE_STATEMENT, CREATION_REFERENCE, DIMENSION, DO_STATEMENT, EMPTY_STATEMENT, ENHANCED_FOR_STATEMENT, ENUM_CONSTANT_DECLARATION, ENUM_DECLARATION, EXPORTS_DIRECTIVE, EXPRESSION_METHOD_REFERENCE, EXPRESSION_STATEMENT, FIELD_ACCESS, FIELD_DECLARATION, FOR_STATEMENT, IF_STATEMENT, IMPORT_DECLARATION, INFIX_EXPRESSION, INITIALIZER, INSTANCEOF_EXPRESSION, INTERSECTION_TYPE, JAVADOC, LABELED_STATEMENT, LAMBDA_EXPRESSION, LINE_COMMENT, MALFORMED, MARKER_ANNOTATION, MEMBER_REF, MEMBER_VALUE_PAIR, METHOD_DECLARATION, METHOD_INVOCATION, METHOD_REF, METHOD_REF_PARAMETER, MODIFIER, MODULE_DECLARATION, MODULE_MODIFIER, NAME_QUALIFIED_TYPE, NORMAL_ANNOTATION, NULL_LITERAL, NUMBER_LITERAL, OPENS_DIRECTIVE, ORIGINAL, PACKAGE_DECLARATION, PARAMETERIZED_TYPE, PARENTHESIZED_EXPRESSION, POSTFIX_EXPRESSION, PREFIX_EXPRESSION, PRIMITIVE_TYPE, PROTECT, PROVIDES_DIRECTIVE, QUALIFIED_NAME, QUALIFIED_TYPE, RECOVERED, REQUIRES_DIRECTIVE, RETURN_STATEMENT, SIMPLE_NAME, SIMPLE_TYPE, SINGLE_MEMBER_ANNOTATION, SINGLE_VARIABLE_DECLARATION, STRING_LITERAL, SUPER_CONSTRUCTOR_INVOCATION, SUPER_FIELD_ACCESS, SUPER_METHOD_INVOCATION, SUPER_METHOD_REFERENCE, SWITCH_CASE, SWITCH_EXPRESSION, SWITCH_STATEMENT, SYNCHRONIZED_STATEMENT, TAG_ELEMENT, TEXT_BLOCK, TEXT_ELEMENT, THIS_EXPRESSION, THROW_STATEMENT, TRY_STATEMENT, TYPE_DECLARATION, TYPE_DECLARATION_STATEMENT, TYPE_LITERAL, TYPE_METHOD_REFERENCE, TYPE_PARAMETER, UNION_TYPE, USES_DIRECTIVE, VARIABLE_DECLARATION_EXPRESSION, VARIABLE_DECLARATION_FRAGMENT, VARIABLE_DECLARATION_STATEMENT, WHILE_STATEMENT, WILDCARD_TYPE, YIELD_STATEMENT`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`SimpleName` `getName()` Returns the name of the type variable declared in this type parameter.
`List` `modifiers()` Returns the live ordered list of modifiers for this TypeParameter node (added in JLS8 API).
`static List` `propertyDescriptors​(int apiLevel)` Returns a list of structural property descriptors for this node type.
`ITypeBinding` `resolveBinding()` Resolves and returns the binding for this type parameter.
`void` `setName​(SimpleName typeName)` Sets the name of the type variable of this type parameter to the given name.
`List` `typeBounds()` Returns the live ordered list of type bounds of this type parameter.

### Methods inherited from class org.eclipse.jdt.core.dom.ASTNode

`accept, copySubtree, copySubtrees, delete, equals, getAST, getFlags, getLength, getLocationInParent, getNodeType, getParent, getProperty, getRoot, getStartPosition, getStructuralProperty, hashCode, nodeClassForType, properties, setFlags, setProperty, setSourceRange, setStructuralProperty, structuralPropertiesForType, subtreeBytes, subtreeMatch, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### MODIFIERS_PROPERTY

    public static final ChildListPropertyDescriptor MODIFIERS_PROPERTY

The "modifiers" structural property of this node type (element type: `IExtendedModifier`) (added in JLS8 API).

Since:
  3.10

#### NAME_PROPERTY

    public static final ChildPropertyDescriptor NAME_PROPERTY

The "name" structural property of this node type (child type: `SimpleName`).

#### TYPE_BOUNDS_PROPERTY

    public static final ChildListPropertyDescriptor TYPE_BOUNDS_PROPERTY

The "typeBounds" structural property of this node type (element type: `Type`).

### Method Detail

#### propertyDescriptors

    public static List propertyDescriptors​(int apiLevel)

Returns a list of structural property descriptors for this node type. Clients must not modify the result.

Parameters:
  `apiLevel` - the API level; one of the `AST.JLS*` constants
Returns:
  a list of property descriptors (element type: `StructuralPropertyDescriptor`)

#### getName

    public SimpleName getName()

Returns the name of the type variable declared in this type parameter.

Returns:
  the name of the type variable

#### resolveBinding

    public final ITypeBinding resolveBinding()

Resolves and returns the binding for this type parameter.

Note that bindings are generally unavailable unless requested when the AST is being built.

Returns:
  the binding, or `null` if the binding cannot be resolved

#### setName

    public void setName​(SimpleName typeName)

Sets the name of the type variable of this type parameter to the given name.

Parameters:
  `typeName` - the new name of this type parameter
Throws:
  `IllegalArgumentException` - if:
  - the node belongs to a different AST
  - the node already has a parent

#### typeBounds

    public List typeBounds()

Returns the live ordered list of type bounds of this type parameter. For the type parameter to be plausible, there can be at most one class in the list, and it must be first, and the remaining ones must be interfaces; the list should not contain primitive types (but array types and parameterized types are allowed).

Returns:
  the live list of type bounds (element type: `Type`)

#### modifiers

    public List modifiers()

Returns the live ordered list of modifiers for this TypeParameter node (added in JLS8 API).

Returns:
  the live list of modifiers (element type: `IExtendedModifier`)
Throws:
  `UnsupportedOperationException` - if this operation is used in a JLS2, JLS3 or JLS4 AST
Since:
  3.10